#include <iom163v.h>
#include <macros.h>

#define lcddi	BIT(7)           //LCD D/I pin connected to PD7
#define lcdrw	BIT(6)           //LCD r/w pin connected to PD6
#define lcde	BIT(5)           //LCD e pin connected to PD5
#define lcdcs1	BIT(4)           //
#define lcdcs2	BIT(3)           //

void write_lcd(unsigned char data);
void Delay4ms(void);
void E_strobe(void);
void command(unsigned char page);
void Lcd_Init(void);
void show_string(char *data, char y, char maxx, char inverse);
void cls(void);
void cs1(void);
void cs2(void);

//extern const unsigned char font5x7[];

void cls(void){
unsigned char page, temp;
for(page=0;page<8;page++){
	command(page);
	PORTD |=  lcdcs1;	//Enable the CS1 of the display
	PORTD |=  lcdcs2;	//Enable the CS2 of the display
	for(temp=0;temp<64;temp++){
		if (page == 3){
			write_lcd(0x80);
		}
		else{
			write_lcd(0x00);
		}
	}
}
}

void cs1(void){
PORTD |=  lcdcs1;	//Enable the CS1 of the display
PORTD &= ~lcdcs2;	//Disable the CS2 of the display
}

void cs2(void){
PORTD |=  lcdcs2;	//Enable the CS2 of the display
PORTD &= ~lcdcs1;	//Disable the CS1 of the display
}

void Lcd_Init(void){
PORTD |=  lcdcs1;	//Enable the CS1 of the display
PORTD |=  lcdcs2;	//Enable the CS2 of the display
PORTD &= ~lcddi;
PORTD &= ~lcdrw;
Delay4ms();

PORTC = 0xc0<<4;		//Display start line = 0 (0-63)
PORTA = 0xc0;
E_strobe();
Delay4ms();
PORTC = 0x40<<4;		//Set address = 0 (0-63)
PORTA = 0x40;
E_strobe();
Delay4ms();
PORTC = 0xb8<<4;		//Set page = 0 (0-7)
PORTA = 0xB8;
E_strobe();
Delay4ms();
PORTC = 0x3f<<4;		//Display ON
PORTA = 0x3F;
E_strobe();
Delay4ms();
PORTD &= ~lcdcs1;	//Disable the CS1 of the display
PORTD &= ~lcdcs2;	//Disable the CS2 of the display
}

void E_strobe(void){
char a;
PORTD |=  lcde;	//E high
for(a=0;a<0xff;a++){NOP();}
PORTD &= ~lcde;	//E low
}

void write_lcd(unsigned char data){
PORTD |=  lcddi;
PORTD &= ~lcdrw;
PORTC = data<<4;
PORTA = data;
E_strobe();
}

void command(unsigned char page){
PORTD |=  lcdcs1;	//Enable the CS1 of the display
PORTD |=  lcdcs2;	//Enable the CS2 of the display
PORTD &= ~lcddi;
PORTC = (0xB8 + page)<<4;
PORTA = 0xB8 + page;
E_strobe();
PORTD |=  lcddi;
}

void Delay4ms(void){
unsigned int time;
for (time=0;time<0x3C00;time++){NOP();}
}
