//ICC-AVR application builder : 22.02.2006 18:17:27
// Target : 8515
// Crystal: 7.3728Mhz

#include <io8515v.h>
#include <macros.h>
///////////////////////////////////////////////////////////////////////////////
#define RD_WR	PD7
#define CLC_CPU	PD6
#define VDRV	PD5
#define C_RES	PD4
#define FA		PB0
#define FB		PB1
#define FC		PB2
#define RAM_END	PB3
///////////////////////////////////////////////////////////////////////////////

char paket=0;

void port_init(void){
 PORTA = 0xFF;
 DDRA  = 0x00;
 PORTB = 0xF8;
 DDRB  = 0x07;
 PORTC = 0xFF;
 DDRC  = 0x00;
 PORTD = 0x00;
 DDRD  = 0xFC; 
}
///////////////////////////////////////////////////////////////////////////////
//UART0 initialisation
void uart0_init(void){
 UCR  = 0x00; //disable while setting baud rate
 UBRR = 0x03; //set baud rate 115200
// UBRR = 0x0B; //set baud rate 38400
 UCR  = 0xD8; //enable
}
///////////////////////////////////////////////////////////////////////////////
#pragma interrupt_handler uart0_rx_isr:10
void uart0_rx_isr(void){ //uart has received a character in UDR
char temp;
	temp = UDR;
	if(temp == 'A'){paket=1;}
}
///////////////////////////////////////////////////////////////////////////////
#pragma interrupt_handler uart0_tx_isr:12
void uart0_tx_isr(void){ //character has been transmitted

}
///////////////////////////////////////////////////////////////////////////////
//call this routine to initialise all peripherals
void init_devices(void){
 //stop errant interrupts until set up
 CLI(); //disable all interrupts
 port_init();
 uart0_init();

 MCUCR = 0x00;
 GIMSK = 0x00;
 TIMSK = 0x00;
 SEI(); //re-enable interrupts
 //all peripherals are now initialised
}
///////////////////////////////////////////////////////////////////////////////
void putchar( unsigned char data )
{       while ( !(USR & (1<<UDRE)) );       // wait for empty transmit buffer //
        UDR = data;                            // start transmittion //
}
///////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////
void main(void){
unsigned char prev, curr, trigger = 0x80, temp, tf=0;
int index; 
 init_devices();
// 
PORTD |= BIT(VDRV);
// 
PORTD &= ~BIT(RD_WR);

PORTD |= BIT(C_RES);	
 
 while(1){
	
	if(paket){
 
// 
//==============================================================================
//  
	 PORTB &= ~BIT(FA);
	 //PORTB |=  BIT(FA);
	 PORTB &= ~BIT(FB);
	 //PORTB |=  BIT(FB);
	 PORTB &= ~BIT(FC);
// 
	PORTD &= ~BIT(RD_WR);
// 
	PORTD &= ~BIT(VDRV);
// 
	PORTD |= BIT(C_RES);
	NOP();
	PORTD &= ~BIT(C_RES);
//   
	while((PINB & 0x08)==0){}
// 
//==============================================================================
//     
	 PORTB |= BIT(FA);
	 PORTB |= BIT(FB);
	 PORTB |= BIT(FC);
// 
	PORTD |= BIT(VDRV);
//   
	PORTD |= BIT(RD_WR); 
// 
	PORTD |= BIT(C_RES);
	NOP();
	PORTD &= ~BIT(C_RES);
//  trigger 
	index=0;
	temp=1;
	while(temp){
		prev = curr;
		//CLC_CPU
		PORTD |= BIT(CLC_CPU);
		NOP();
		PORTD &= ~BIT(CLC_CPU);
		curr = PINA;
		index++;
//trigger 
//		if (prev == trigger &&  PINA > trigger){
		if (prev == 128 && curr > 130){
			temp = 0;
			if(index < 32768){tf=1;}
		}
//trigger not found
		if(index == 32768){
			temp = 0;
			// 
//			PORTD |= BIT(C_RES);
//			NOP();
//			PORTD &= ~BIT(C_RES);
			tf=1;
		}	
	}		
if(tf){
//  
//==============================================================================
		//header
		putchar(0xAA); putchar(0x55);
		putchar(0xAA); putchar(0x55);
		//memory
		for (index = 0; index < 400; index++){
			//CLC_CPU
			PORTD |= BIT(CLC_CPU);
			NOP();
			PORTD &= ~BIT(CLC_CPU);	

			putchar(PINA);
		}
//	tf=0;
}
//==============================================================================
			PORTD |= BIT(C_RES);
			paket=0;
			}
 }//end main while
}// end main(void)

